routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/webhook', 'BackEndController@verify_token');
Route::post('/webhook', 'BackEndController@verify_token');

Route::group(['prefix' => 'admin','middleware'=>['auth','admin']], function () {
    Route::get('dashboard', 'BackEndController@Dashboard')->name('admin.dashboard');

    Route::get('sms-setting', 'SmsSettingController@smsSetting')->name('smsSetting');
    Route::post('update-sms-setting', 'SmsSettingController@updateSmsSetting')->name('updateSmsSetting');



    Route::get('general-setting', 'GeneralSettingController@index')->name('general_setting');
    Route::POST('update-general-setting', 'GeneralSettingController@update')->name('update-general-setting');
    Route::POST('update-logo', 'GeneralSettingController@updateLogo')->name('update-logo');
    Route::POST('update-fav', 'GeneralSettingController@updateFav')->name('update-fav');

    // pms start

    Route::get('app-setting', 'GeneralSettingController@appSetting')->name('appSetting');
    Route::post('update-app-setting', 'GeneralSettingController@updateAppSetting')->name('updateAppSetting');

    // Route::resource('post', 'PostController');
    Route::get('post', 'PostController@index')->name('post.index');
    Route::get('post/create', 'PostController@create')->name('post.create');
    Route::post('post/store', 'PostController@store')->name('post.store');
    Route::get('post/{id}/edit', 'PostController@edit')->name('post.edit');
    Route::post('post/update/{id}', 'PostController@update')->name('post.update');
    Route::get('post/destroy/{id}', 'PostController@destroy')->name('post.destroy');

    // Route::get('already-posted', 'PostController@alreadyPosted')->name('alreadyPosted');
    Route::get('already-posted', 'GraphController@getAllPost')->name('alreadyPosted');
    Route::get('delete-already-posted/{id}', 'GraphController@deleteAlreadyPosted')->name('deleteAlreadyPosted');
    Route::get('fb-post-details/{post_id}', 'GraphController@postDetails')->name('fbPostDetails');
    Route::get('individual-photo-details/{id}', 'GraphController@individualPhotoDetails')->name('individualPhotoDetails');

    Route::post('post-comment', 'GraphController@postCommentStore')->name('postCommentStore');
    Route::post('comment-reply', 'GraphController@commentReplyStore')->name('commentReplyStore');
    Route::get('delete-comment/{id}', 'GraphController@deleteComment')->name('deleteComment');


    Route::get('user-info-get/{user_id}', 'GraphController@userInfoGet')->name('userInfoGet');
    Route::get('page-info-get', 'GraphController@pageInfoGet')->name('pageInfoGet');

    Route::get('post-details/{post_id}', 'PostController@postDetails')->name('postDetails');



    Route::post('/getall', 'PostController@getall')->name('getall');
    Route::post('/getmodal', 'PostController@getmodal')->name('getmodal');

    Route::resource('profile', ProfileController::class);
    // Route::get('profile', 'ProfileController@index')->name('profile');
    Route::get('/facebook', 'ProfileController@redirectToFacebookProvider')->name('facebook');
    Route::get('facebook/callback', 'ProfileController@handleProviderFacebookCallback');
    Route::post('facebook_page_id', 'ProfileController@facebook_page_id')->name('facebook_page_id');


    Route::post('publish-to-page', 'GraphController@publishToPage')->name('publishToPage');

    Route::prefix('apps')->group(function() {
        Route::get('/', 'FacebookAppController@index')->name('apps');
        Route::post('/store','FacebookAppController@store')->name('apps.store');
        Route::post('/update','FacebookAppController@update')->name('apps.update');
        Route::get('/edit/{id}','FacebookAppController@edit')->name('apps.edit');
        Route::get('/delete/{id}','FacebookAppController@destroy')->name('apps.delete');
        Route::post('/update-active-status','FacebookAppController@update_active_status')->name('apps.update_active_status');
    });
    Route::prefix('fb-page')->group(function() {
        Route::get('/', 'FacebookPageController@index')->name('fbPage');
        Route::post('/store','FacebookPageController@store')->name('fbPage.store');
        Route::post('/update','FacebookPageController@update')->name('fbPage.update');
        Route::get('/edit/{id}','FacebookPageController@edit')->name('fbPage.edit');
        Route::get('/delete/{id}','FacebookPageController@destroy')->name('fbPage.delete');
        Route::post('/update-active-status','FacebookPageController@update_active_status')->name('fbPage.update_active_status');
    });

});



Route::group(['middleware'=>['auth','userVerified']], function () {
    // Profile
    Route::get('profile', 'GeneralSettingController@Profile');
    Route::POST('update-profile-image', 'GeneralSettingController@updateprofileImage')->name('update-profile-image');
    Route::POST('update-profile-info', 'GeneralSettingController@updateprofileInfo')->name('update-profile-info');
    Route::post('change-pass', 'GeneralSettingController@passwordUpdate');

});
    Route::get('/verification', 'OTPVerificationController@verification')->name('verification');
    Route::post('/verification', 'OTPVerificationController@verify_phone')->name('verification.submit');
    Route::get('/verification/phone/code/resend', 'OTPVerificationController@resend_verificcation_code')->name('verification.phone.resend');
    Route::get('/home', 'HomeController@index')->name('home');
    Route::any('password/reset/phone', 'OTPVerificationController@sendResetCode')->name('password.phone');
    Route::post('/password/reset/phone/submit', 'OTPVerificationController@reset_password_with_code')->name('password.update');

app/Profile.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Profile extends Model
{
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'profiles';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = ['name', 'image', 'message', 'status', 'fb_id', 'fb_post_id'];
}

app/Http/Controllers/ProfileController.php
<?php

namespace App\Http\Controllers;

use App\User;
use Exception;
use Facebook\Facebook;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Validator;
use Laravel\Socialite\Facades\Socialite;

class ProfileController extends Controller
{
    public function index()
    {
        return view('profile.index');
    }

    public function store(Request $request)
    {
        $input = $request->all();
        $rules = [
            'name'=> 'required'
        ];
        $validator = Validator::make($input, $rules);
        if ($validator->fails()){
            $arr = ['status' =>400, "msg" => $validator->errors()->first(), 'result'=>[]];
        }else {
            try {
                $user = User::find(Auth::id());
                $user->name = $request->name;
                $user->save();
                $msg ='profile update successfully';
                $arr = array("status" => 200, "msg" => $msg );
            } catch (Exception $ex) {
                $msg = $ex->getMessage();
                if (isset($ex->errorInfo[2]))
                {
                    $msg = $ex->errorInfo[2];
                }
                $arr = array("status" => 400, "msg" => $msg,"result" => array() );
            }
        }
        return \Response::json($arr);
    }

    public function redirectToFacebookProvider()
    {
        return Socialite::driver('facebook')->scopes([
            "public_profile, pages_show_list", "pages_read_engagement", "pages_manage_posts", "pages_manage_metadata"
        ])->redirect();
    }
    // public function redirectToFacebookProvider()
    // {
    //     return Socialite::driver('facebook')->scopes([
    //         "public_profile, pages_show_list", "pages_read_engagement", "pages_manage_posts", "pages_manage_metadata", "user_videos", "user_posts"
    //     ])->redirect();
    // }

    public function handleProviderFacebookCallback()
    {
        $auth_user = Socialite::driver('facebook')->user();

        DB::table('users')
              ->where('id', Auth::id())
              ->update([
                'token' => $auth_user->token,
                'facebook_app_id'  =>  $auth_user->id,
              ]);
        return redirect()->to('/admin/app-setting');
    }

    public function facebook_page_id(Request $request)
    {
        $input = $request->all();
        $rules = [
            'facebook_page_id'=> 'required'
        ];
        $validator = Validator::make($input, $rules);
        if ($validator->fails()){
            $arr = ['status' =>400, "msg" => $validator->errors()->first(), 'result'=>[]];
        }else {
            try {
                $user = User::find(Auth::id());
                $user->facebook_page_id = $request->facebook_page_id;
                $user->save();
                $msg ='page id update successfully';
                $arr = array("status" => 200, "msg" => $msg );
            } catch (Exception $ex) {
                $msg = $ex->getMessage();
                if (isset($ex->errorInfo[2]))
                {
                    $msg = $ex->errorInfo[2];
                }
                $arr = array("status" => 400, "msg" => $msg,"result" => array() );
            }
        }
        return \Response::json($arr);

    }

}

resources/views/admin/profile/index.blade.php
@extends('admin.master')

@section('mainContent')
<style>
    fieldset {
        line-height: 16px;
        padding: 0 10px;
        border: 1px solid #e0e0e0;
        background-color: rgb(232 232 232 / 30%);
        margin: 5px;
    }

    legend {
        background-color: #fff;
        width: inherit;
        padding: 0 10px;
        border-bottom: none;
        border: 1px solid #e0e0e0;
        padding: 10px;
    }
</style>
<div class="container">
    <div class="main-body">
        <div class="row">
            <div class="col-lg-4">
                <div class="card">
                    <div class="card-body">
                        <div class="d-flex flex-column align-items-center text-center">
                            <img src="https://bootdey.com/img/Content/avatar/avatar7.png" alt="Admin"
                                class="rounded-circle p-1 bg-danger" width="110">
                            <div class="mt-3">
                                <h4>{{ auth()->user()->name ??''}}</h4>
                                <p class="text-secondary mb-1">{{ auth()->user()->email ??''}}</p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-8">
                <div class="card">
                    <div class="card-body">
                        <fieldset>
                            <legend>User Data</legend>
                            <form action="{{route('profile.store')}}" class="formsubmit" method="post"
                                enctype="multipart/form-data">
                                @csrf
                                <div class="row mb-3">
                                    <div class="col-sm-3">
                                        <h6>Name</h6>
                                    </div>
                                    <div class="col-sm-9">
                                        <input type="text" name="name" class="form-control" required
                                            value="{{Auth::user()->name??''}}">
                                    </div>
                                </div>
                                <div class="row mb-3">
                                    <div class="col-sm-3">
                                        <h6 class="mb-0">Email</h6>
                                    </div>
                                    <div class="col-sm-9 text-secondary">
                                        <input type="email" class="form-control" name="email"
                                            value="{{ auth()->user()->email ??''}}" required readonly>
                                    </div>
                                </div>
                                <div class="row mb-2">
                                    <div class="col-sm-3"></div>
                                    <div class="col-sm-9 text-secondary">
                                        <button type="submit" class="btn btn-primary px-4">Save Changes <span
                                                class="submitspinner"></span></button>
                                    </div>
                                </div>

                            </form>
                        </fieldset>

                        <fieldset>
                            <legend>Facebook App and Page</legend>
                            <form action="{{route('updateAppSetting')}}" method="post"
                                enctype="multipart/form-data">
                                @csrf
                                <div class="row mb-3">
                                    <div class="col-sm-3">
                                        <h6>Facebook App</h6>
                                    </div>
                                    <div class="col-sm-9">
                                        <select name="facebook_app_id" class="form-control" required>
                                            <option value="">Select App</option>
                                            @foreach ($apps as $app)
                                                <option value="{{$app->app_id}}" {{$app->app_id == Auth::user()->facebook_app_id ? 'selected': ''}} >{{$app->name}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <div class="row mb-3">
                                    <div class="col-sm-3">
                                        <h6>Facebook Page</h6>
                                    </div>
                                    <div class="col-sm-9">
                                        <select name="facebook_page_id" class="form-control" required>
                                            <option value="">Select Page</option>
                                            @foreach ($pages as $page)
                                                <option value="{{$page->page_id}}" {{$page->page_id == Auth::user()->facebook_page_id? 'selected' : ''}} >{{$page->name}}</option>
                                            @endforeach
                                        </select>
                                    </div>
                                </div>
                                <div class="row mb-2">
                                    <div class="col-sm-3"></div>
                                    <div class="col-sm-9 text-secondary">
                                        <button type="submit" class="btn btn-primary px-4">Save Changes</button>
                                    </div>
                                </div>
                            </form>
                        </fieldset>


                        <fieldset>
                            <legend>Facebook Token</legend>
                            <div class="row mb-3">
                                <div class="col-sm-10">
                                    <input type="text" class="form-control" value="{{Auth::user()->token ??''}}"
                                        readonly>
                                </div>
                                <div class="col-sm-2">
                                    <a href="{{route('facebook')}}" class="btn btn-info px-4 " title="click"> <i
                                            class="fa fa-key" aria-hidden="true"></i></a>
                                </div>
                            </div>
                            {{-- <div class="row mb-3">
                                <div class="col-sm-10">
                                    <input type="text" class="form-control facebook_page_id" name="facebook_page_id"
                                        placeholder="facebook_page_id" value="{{Auth::user()->facebook_page_id ??''}}"
                                        required>
                                </div>
                                <div class="col-sm-2">
                                    <a href="javascript:void(0)" class="btn btn-info px-4 store_page_id"
                                        title="click"><i class="fa fa-upload" aria-hidden="true"></i> <samp
                                            class="submitspinnerpage"></samp></a>
                                </div>
                            </div> --}}
                        </fieldset>
                    </div>
                </div>
            </div>
        </div>

    </div>
</div>
@push('script')
<script>
    $( document ).ready(function() {
            $('body').on('submit', '.formsubmit', function(e) {
                e.preventDefault();
                $.ajax({
                    url:$(this).attr('action'),
                    data:new FormData(this),
                    type:'POST',
                    contentType: false,
                    cache: false,
                    processData: false,
                    beforeSend: function () {
                        $('.submitspinner').html('<i class="fa fa-spinner fa-spin"></i>')
                    },
                    success: function (data) {
                    $('.submitspinner').html('');
                    if (data.status==200) {
                        $.confirm({
                            title: 'Success!',
                            content: data.msg,
                            autoClose: 'cancelAction|3000',
                            buttons: {
                                cancelAction: function (e) {}
                            }
                        });
                    }
                    if (data.status==400) {
                        $.alert({
                            title: 'Success!',
                            content: data.msg,
                        });
                    }
                    },
                })
            });

            // $('body').on('click', '.store_page_id', function(e) {
            //     var data = $('.facebook_page_id').val();
            //     $.ajax({
            //     url: '{{route("facebook_page_id")}}',
            //     data: {facebook_page_id:data},
            //     type: 'POST',
            //     headers: {
            //         'X-CSRF-TOKEN': '{{ csrf_token() }}'
            //     },
            //     beforeSend: function () {
            //         $('.submitspinnerpage').html('<i class="fa fa-spinner fa-spin"></i>')
            //     },
            //     success: function (data) {
            //         $('.submitspinnerpage').html('');
            //         if (data.status == 200) {
            //             $.confirm({
            //                 title: 'Success!',
            //                 content: data.msg,
            //                 autoClose: 'cancelAction|3000',
            //                 buttons: {
            //                     cancelAction: function (e) {}
            //                 }
            //             });
            //         }
            //         if (data.status == 400) {
            //             $.alert({
            //                 title: 'Alert!',
            //                 content: data.msg,
            //             });
            //         }
            //     },
            // });
            // });
        });
</script>

@endpush
@endsection